> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Read factual hosted usage for an optional closed time window



## OpenAPI

````yaml /api-reference/openapi.json get /v1/organization/usage
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
tags:
  - name: authentication
    description: Sessions, CLI exchange, credentials, and verification keys.
    x-group: Authentication
  - name: organizations
    description: Organization members, billing, usage, retention, audit, and exports.
    x-group: Organizations
  - name: projects
    description: Project lifecycle, access, grants, and repository bindings.
    x-group: Projects
  - name: builds
    description: Immutable builds, uploads, source drafts, and world definitions.
    x-group: Builds and source
  - name: tools
    description: Project Tool discovery, approval, source, and revocation.
    x-group: Tool library
  - name: worlds
    description: >-
      Managed environments, world sessions, state, time, reset, faults, forks,
      and snapshots.
    x-group: Environments and sessions
  - name: runs
    description: >-
      Hosted runs, comparisons, attachments, reports, evidence bundles, sharing,
      and exports.
    x-group: Runs and evidence
  - name: browser
    description: Managed browser tests, runs, messages, streams, frames, and artifacts.
    x-group: Browser testing
  - name: callbacks
    description: Callback receiver approval, revocation, and signing material.
    x-group: Callbacks
  - name: github-ci
    description: >-
      GitHub installations, repository automation, CI suites, cases, evidence,
      and checks.
    x-group: GitHub and CI
  - name: authoring
    description: Authoring sessions, proposals, turns, and scenario proposals.
    x-group: Cloud authoring
paths:
  /v1/organization/usage:
    get:
      tags:
        - organizations
      summary: Read factual hosted usage for an optional closed time window
      operationId: usage.getOrganization
      parameters:
        - name: fromAtMs
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
        - name: toAtMs
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
      responses:
        '200':
          description: Organization usage
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HostedUsageOverview'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    HostedUsageOverview:
      type: object
      properties:
        schemaVersion:
          type: number
          enum:
            - 1
        organizationId:
          type: string
          pattern: ^org_[0-9a-z]{12,32}$
        entitlement:
          type: object
          properties:
            schemaVersion:
              type: number
              enum:
                - 1
            entitlementId:
              type: string
              pattern: ^entitlement_[0-9a-z]{12,32}$
            organizationId:
              type: string
              pattern: ^org_[0-9a-z]{12,32}$
            plan:
              type: string
              minLength: 1
              maxLength: 80
            limits:
              type: object
              properties:
                maxConcurrentSessions:
                  type: integer
                  minimum: 0
                  maximum: 100000
                maxConcurrentRuns:
                  type: integer
                  minimum: 0
                  maximum: 100000
                maxSessionTtlMs:
                  type: integer
                  minimum: 0
                  exclusiveMinimum: true
                  maximum: 604800000
                maxDrillTimeoutMs:
                  type: integer
                  minimum: 1000
                  maximum: 86400000
                maxEvidenceRetentionMs:
                  type: integer
                  minimum: 0
                  exclusiveMinimum: true
                  maximum: 31536000000
                usage:
                  type: object
                  properties:
                    sessionMs:
                      type: string
                      pattern: ^(0|[1-9][0-9]{0,37})$
                    warmLeaseMs:
                      type: string
                      pattern: ^(0|[1-9][0-9]{0,37})$
                    storageByteMs:
                      type: string
                      pattern: ^(0|[1-9][0-9]{0,37})$
                    transferBytes:
                      type: string
                      pattern: ^(0|[1-9][0-9]{0,37})$
                    drillMs:
                      type: string
                      pattern: ^(0|[1-9][0-9]{0,37})$
                  additionalProperties: false
              required:
                - maxConcurrentSessions
                - maxConcurrentRuns
                - maxSessionTtlMs
                - maxDrillTimeoutMs
                - maxEvidenceRetentionMs
              additionalProperties: false
            effectiveAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            expiresAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
          required:
            - schemaVersion
            - entitlementId
            - organizationId
            - plan
            - limits
            - effectiveAtMs
          additionalProperties: false
        window:
          type: object
          properties:
            fromAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            toAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
          required:
            - fromAtMs
            - toAtMs
          additionalProperties: false
        finalized:
          type: object
          properties:
            derived:
              type: object
              properties:
                sessionMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                warmLeaseMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                storageByteMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                transferBytes:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                drillMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
              required:
                - sessionMs
                - warmLeaseMs
                - storageByteMs
                - transferBytes
                - drillMs
              additionalProperties: false
            recorded:
              type: object
              properties:
                sessionMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                warmLeaseMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                storageByteMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                transferBytes:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
                drillMs:
                  type: string
                  pattern: ^(0|[1-9][0-9]{0,37})$
              required:
                - sessionMs
                - warmLeaseMs
                - storageByteMs
                - transferBytes
                - drillMs
              additionalProperties: false
          required:
            - derived
            - recorded
          additionalProperties: false
        active:
          type: object
          properties:
            sessions:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            runs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
          required:
            - sessions
            - runs
          additionalProperties: false
        reconciliation:
          type: object
          properties:
            status:
              type: string
              enum:
                - current
                - drift
            missingRecords:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            conflictingRecords:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
          required:
            - status
            - missingRecords
            - conflictingRecords
          additionalProperties: false
        generatedAtMs:
          type: integer
          minimum: -9007199254740991
          maximum: 9007199254740991
      required:
        - schemaVersion
        - organizationId
        - entitlement
        - window
        - finalized
        - active
        - reconciliation
        - generatedAtMs
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````